VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmMain 
   Caption         =   "Hand"
   ClientHeight    =   7020
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7110
   Icon            =   "frmMain.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   468
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   474
   StartUpPosition =   2  'CenterScreen
   Begin MSComctlLib.Slider sliderPitch 
      Height          =   1095
      Left            =   6480
      TabIndex        =   4
      Top             =   4080
      Width           =   630
      _ExtentX        =   1111
      _ExtentY        =   1931
      _Version        =   393216
      Orientation     =   1
      Max             =   360
   End
   Begin MSComctlLib.Slider sliderYaw 
      Height          =   390
      Left            =   5400
      TabIndex        =   3
      Top             =   5520
      Width           =   1575
      _ExtentX        =   2778
      _ExtentY        =   688
      _Version        =   393216
      Max             =   360
   End
   Begin VB.CommandButton cmdCycle 
      Caption         =   "Cycle"
      Height          =   615
      Left            =   4800
      TabIndex        =   2
      Top             =   6120
      Width           =   1215
   End
   Begin VB.CommandButton cmdRetreat 
      Caption         =   "Goto Back One Key Frame"
      Height          =   615
      Left            =   2400
      TabIndex        =   1
      Top             =   6120
      Width           =   2175
   End
   Begin VB.CommandButton cmdAdvance 
      Caption         =   "Advance one Key Frame"
      Height          =   615
      Left            =   0
      TabIndex        =   0
      Top             =   6120
      Width           =   2175
   End
   Begin VB.Timer Timer1 
      Left            =   480
      Top             =   4560
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim xDigit_Angle As GLint
Dim bToggle As Boolean

Private Sub cmdCycle_Click()
    If Timer1.Interval = 0 Then
        Timer1.Interval = 100
        bToggle = False
    Else
        Timer1.Interval = 0
    End If
End Sub

Private Sub cmdRetreat_Click()
    If (iKey - 1) > -1 Then
        iKey = iKey - 1
        Form_Paint
    End If
End Sub

Private Sub cmdAdvance_Click()
    If iKey + 1 < KEY_INDEX_COUNT Then
        iKey = iKey + 1
        Form_Paint
    End If
End Sub

Private Sub Form_Load()

    On Error GoTo BadInit
    Dim hGLRC As Long
    Dim fASpect As GLfloat
    
    spin = 0

    SetupPixelFormat hDC
    
    hGLRC = wglCreateContext(hDC)
    wglMakeCurrent hDC, hGLRC
    glEnable GL_DEPTH_TEST
    glEnable GL_DITHER
    glDepthFunc GL_LESS
    glClearDepth 1
    glClearColor 0.5, 0.5, 0.5, 1
    
    glMatrixMode GL_PROJECTION
    glLoadIdentity
    If frmMain.ScaleHeight > 0 Then
    fASpect = frmMain.ScaleWidth / frmMain.ScaleHeight
    Else
    fASpect = 0
    End If
    
    gluPerspective 60, fASpect, 1, 2000
    glViewport 0, 0, frmMain.ScaleWidth, frmMain.ScaleHeight

    glMatrixMode GL_MODELVIEW
    glLoadIdentity

    glEnable GL_LIGHTING
    glEnable GL_LIGHT0
    glShadeModel GL_SMOOTH
    glFrontFace GL_CCW
    
    
    glLightModelf GL_LIGHT_MODEL_TWO_SIDE, 1#
    glPolygonMode GL_FRONT_AND_BACK, GL_FILL


    lmodel_ambient(0) = 0.8
    lmodel_ambient(1) = 0.8
    lmodel_ambient(2) = 0.8
    lmodel_ambient(3) = 1
    
    glLightModelfv GL_LIGHT_MODEL_Ambient, lmodel_ambient(0)
    
    glMateriali GL_FRONT, GL_SHININESS, 50
    
    Call DefineKeyFrame
    
    m_Palm = BuildTextureCube(0.5)
    m_Digit = BuildTextureCube(0.25)
    
    Form_Paint
    Exit Sub
BadInit:
    MsgBox "Error #" & CStr(Err.Number) & " has occured in " & CStr(Err.Source) & " during initialization." & Chr(13) & Chr(10) & Chr$(13) & Chr$(10) & "Description: " & Err.Description
    Exit Sub
End Sub
Private Sub Form_MouseDown(Button As Integer, Shift As Integer, x As Single, Y As Single)
    spin = (spin + 20) Mod 360
    Form_Paint
End Sub
Private Sub Form_Paint()
    On Error GoTo BadRender
    Dim iKeyFrame As GLint
    
    Dim position(3) As GLfloat
    position(0) = 0
    position(1) = 0
    position(2) = 1.5
    position(3) = 1
    glClear GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT
    
    'Moveable Light
    glPushMatrix
        glTranslatef 0, 0, -5
        glPushMatrix
            glRotated spin, 1, 0, 0
            glRotated 0, 1, 0, 0
            glLightfv GL_LIGHT0, GL_POSITION, position(0)
            glTranslated 0, 0, 2.5
            glDisable GL_LIGHTING
                glColor3f 1, 1, 0
                auxSolidSphere 0.05
            glEnable GL_LIGHTING
        glPopMatrix
    glPopMatrix
    
    'Hand
    glPushMatrix
        glTranslatef 0, -0.5, -7
        glRotatef sliderYaw.Value, 0, 1, 0
        glRotatef sliderPitch.Value, 1, 0, 0
        glPushMatrix
            glScalef 3#, 2, 0.5
            glCallList m_Palm
        glPopMatrix
        glPushMatrix
            glTranslatef 1#, 1.25, 0#
            iKeyFrame = vIndex(iKey, FIRST_FINGER)
            Call Finger(iKeyFrame)
        glPopMatrix
        glPushMatrix
            glTranslatef 0.25, 1.25, 0#
            iKeyFrame = vIndex(iKey, SECOND_FINGER)
            Call Finger(iKeyFrame)
        glPopMatrix
        glPushMatrix
            glTranslatef -0.5, 1.25, 0#
            iKeyFrame = vIndex(iKey, THIRD_FINGER)
            Call Finger(iKeyFrame)
        glPopMatrix
        glPushMatrix
            glTranslatef -1.25, 1.25, 0#
            iKeyFrame = vIndex(iKey, FOURTH_FINGER)
            Call Finger(iKeyFrame)
        glPopMatrix
        
        glPushMatrix
            glTranslatef 0.85, -0.25, 0.2
            
            glPushMatrix
            glRotatef -50, 0, 0, 1
            iKeyFrame = vIndex(iKey, THUMB_FINGER)
            Call Thumb(iKeyFrame)
            glPopMatrix
        glPopMatrix
        
    glPopMatrix

    SwapBuffers hDC
    
    
    Exit Sub
BadRender:
    MsgBox "Error #" & CStr(Err.Number) & " has occured in " & CStr(Err.Source) & " during rendering." & Chr$(13) & Chr$(10) & Chr$(13) & Chr$(10) & "Description: " & Err.Description
    Exit Sub
End Sub
Private Sub Finger(iKey As GLint)
    Dim theta As GLfloat
    
    glPushMatrix
        'First Digit
        theta = vFingerKeyFrame(iKey, 0)
        glTranslatef 0, -0.25, 0
        glRotatef theta, 1, 0, 0
        glTranslatef 0, 0.25, 0
        glCallList m_Digit
       
        'Second Digit
        theta = vFingerKeyFrame(iKey, 1)

        glTranslatef 0, 0.5, 0
        
        glPushMatrix
        glTranslatef 0, -0.25, 0
        glRotatef theta, 1, 0, 0
        glTranslatef 0, 0.25, 0
        glCallList m_Digit
        
        'Third Digit
        theta = vFingerKeyFrame(iKey, 2)

        glTranslatef 0, 0.5, 0
        
        glPushMatrix
        glTranslatef 0, -0.25, 0
        glRotatef theta, 1, 0, 0
        glTranslatef 0, 0.25, 0
        glCallList m_Digit
        
        glPopMatrix
        
        glPopMatrix
        
    glPopMatrix
    
End Sub
Private Sub Thumb(iKey As GLint)
Dim theta As GLfloat

    glPushMatrix
        
        'Digit 1
        
        glTranslatef 0, -0.5, 0
        glRotatef 30, 1, 0, 0
        glTranslatef 0, 0.5, 0
        
        glPushMatrix
        glScalef 1, 3.5, 1
        glCallList m_Digit
        glPopMatrix
       
        'Digit 2
        theta = vThumbKeyFrame(iKey, 1)
        glTranslatef 0, 1.1, 0
        
        glPushMatrix
        glTranslatef -0.25, 0, 0
        glTranslatef 0, -0.25, 0
        
        glRotatef theta, 0, 0, 1
        glTranslatef 0.25, 0, 0
        glTranslatef 0, 0.25, 0
        
        glCallList m_Digit
    
        'Digit 3
        theta = vThumbKeyFrame(iKey, 2)
        glTranslatef 0, 0.75, 0
        
        glPushMatrix
        glTranslatef -0.25, 0, 0
        glTranslatef 0, -0.5, 0
        glRotatef theta, 0, 0, 1
        glTranslatef 0, 0.5, 0
        glTranslatef 0.25, 0, 0
        glPushMatrix
        glScalef 1, 2#, 1
        glCallList m_Digit
        glPopMatrix
        
        glPopMatrix
        
        
        glPopMatrix
        
    glPopMatrix

End Sub
Private Sub Form_Resize()

    On Error GoTo BadResize
    
    glViewport 0, 0, frmMain.ScaleWidth, frmMain.ScaleHeight
    glMatrixMode GL_PROJECTION
    glLoadIdentity
    gluPerspective 40, frmMain.ScaleWidth / frmMain.ScaleHeight, 1, 20
    glMatrixMode GL_MODELVIEW
    
    Form_Paint
    Exit Sub
BadResize:
    MsgBox "Error #" & CStr(Err.Number) & " has occured in " & CStr(Err.Source) & " during resizing." & Chr$(13) & Chr$(10) & Chr$(13) & Chr$(10) & "Description: " & Err.Description
    Exit Sub
End Sub
Private Sub Form_Unload(Cancel As Integer)
    
    If hGLRC <> 0 Then
        wglMakeCurrent 0, 0
        wglDeleteContext hGLRC
    End If
    
    If hPalette <> 0 Then
        DeleteObject hPalette
    End If

End Sub
Private Function BuildTextureCube(x As GLfloat) As GLint

    Dim xt As GLfloat
    Dim rc As GLint
    
    rc = glGenLists(1)
    
    glPushMatrix
    
    glNewList rc, GL_COMPILE_AND_EXECUTE

  'glTexParameterf GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT
  'glTexParameterf GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT
  'glTexParameterf GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR
  'glTexParameterf GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST

  'glTexEnvf GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL
  'glEnable GL_TEXTURE_2D
  'glShadeModel GL_SMOOTH

    'If (m_Texture.GetData() <> Null) Then
    '    glTexImage2D GL_TEXTURE_2D, 0, 3, m_Texture.GetWidth(), m_Texture.GetHeight(), 0, GL_RGB, GL_UNSIGNED_BYTE, m_Texture.GetData()
    'End If
                                 

    xt = 5#
    
    diffuseProperties(0) = 1
    diffuseProperties(1) = 1
    diffuseProperties(2) = 1
    diffuseProperties(3) = 1
    
    glMaterialfv GL_FRONT_AND_BACK, GL_DIFFUSE, diffuseProperties(0)
    
    glBegin GL_POLYGON
        glNormal3d 0#, 0#, -1#
        glTexCoord2f 0#, 0#
        glVertex3d x, x, x
        glTexCoord2f xt, 0#
        glVertex3d x, -x, x
        glTexCoord2f xt, xt
        glVertex3d -x, -x, x
        glTexCoord2f 0#, xt
        glVertex3d -x, x, x
    glEnd

    glBegin GL_POLYGON
        glNormal3d 0#, 0#, 1#
        glTexCoord2f 0#, 0#
        glVertex3d -x, x, -x
        glTexCoord2f 1#, 0#
        glVertex3d -x, -x, -x
        glTexCoord2f 1#, 1#
        glVertex3d x, -x, -x
        glTexCoord2f 0#, 1#
        glVertex3d x, x, -x
    glEnd


    glBegin GL_POLYGON
        glNormal3d -1#, 0#, 0#
        glTexCoord2f 0#, 0#
        glVertex3d x, x, x
        glTexCoord2f 1#, 0#
        glVertex3d x, x, -x
        glTexCoord2f 1#, 1#
        glVertex3d x, -x, -x
        glTexCoord2f 0#, 1#
        glVertex3d x, -x, x
    glEnd


    glBegin GL_POLYGON
        glNormal3d 1#, 0#, 0#
        glTexCoord2f 0#, 0#
        glVertex3d -x, x, x
        glTexCoord2f 1#, 0#
        glVertex3d -x, x, -x
        glTexCoord2f 1#, 1#
        glVertex3d -x, -x, -x
        glTexCoord2f 0#, 1#
        glVertex3d -x, -x, x
    glEnd


    glBegin GL_POLYGON
        glNormal3d 0#, 1#, 0#
        glTexCoord2f 0#, 0#
        glVertex3d -x, -x, x
        glTexCoord2f 1#, 0#
        glVertex3d x, -x, x
        glTexCoord2f 1#, 1#
        glVertex3d x, -x, -x
        glTexCoord2f 0#, 1#
        glVertex3d -x, -x, -x
    glEnd


    glBegin GL_POLYGON
        glNormal3d 0#, -1#, 0#
        glTexCoord2f 0#, 0#
        glVertex3d -x, x, x
        glTexCoord2f 1#, 0#
        glVertex3d x, x, x
        glTexCoord2f 1#, 1#
        glVertex3d x, x, -x
        glTexCoord2f 0#, 1#
        glVertex3d -x, x, -x
    glEnd


  'glDisable GL_TEXTURE_2D

  glEndList

    glPopMatrix
    
    BuildTextureCube = rc
    
End Function


Private Sub Timer1_Timer()
    
    If bToggle = False Then
        If iKey + 1 < KEY_INDEX_COUNT Then
            iKey = iKey + 1
        Else
            bToggle = True
        End If
    Else
        If (iKey - 1) > -1 Then
            iKey = iKey - 1
        Else
            bToggle = False
        End If
    End If
    
    Form_Paint
End Sub
